/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getIntOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getIntOperationDispatcher. It contains of all the generic methods
    for getIntOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getIntOperationDispatcher_HXX
#define getIntOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getIntOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getIntOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getIntOperationDispatcher();
        virtual ~getIntOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        // Project 011450 changes
        void getIntPreConditions( const Teamcenter::BusinessObject* obj, int& value, bool& isNull ) const;
        void getIntPreActions( const Teamcenter::BusinessObject* obj, int& value, bool& isNull ) const;
        void getIntBaseAction( const Teamcenter::BusinessObject* obj, int& value, bool& isNull ) const;
        void getIntPostActions( const Teamcenter::BusinessObject* obj, int& value, bool& isNull ) const;

        void getIntPreConditions( METHOD_message_t*  msgData, int* value, logical* isNull ) const;
        void getIntPreActions( METHOD_message_t*  msgData, int* value, logical* isNull ) const;
        void getIntBaseAction( METHOD_message_t*  msgData, int* value, logical* isNull ) const;
        void getIntPostActions( METHOD_message_t*  msgData, int* value, logical* isNull ) const;

        void getInt( const Teamcenter::BusinessObject* obj, int& value, bool& isNull ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getIntOperationDispatcher_HXX
